//******************************************************************************
// GDImbH  19.06.2020 letzte nderung 20.06.2020
// Corona-Konjunkturpaket Mehrwertsteuerabsenkung 2020
//
// Programm "P1_Button_BelegMaske_Steuersatz.prg"
// Funktion: Prfen+Setzen des Steuersatzes in den Positionen eines Beleges
// Einsetzbar in GDI Busness Line ab Version 3.6
// Einzubinden in einen TsButton in die Belegmaske aller Belegarten (EK und VK)
//******************************************************************************

Sollsatz1 := 16.00;
Sollsatz2 := 5.00;

//********************Steuersatz prfen***************
BP16 := 0;
BP19 := 0;
BP5 := 0;
BP7 := 0;
%TA_Pos.First;
while %TA_Pos.EOF = false do
  StSatz := %TA_Pos.FieldByName('Steuersatz');
  if (%TA_Pos.FieldByName('Artikelnr') <> '') and 
     ((StSatz=16.00) or (StSatz=19.00) or (StSatz=5.00) or (StSatz=7.00)) and
     (Pos(%TA_Pos.FieldByName('KzDruck'), 'PESTt') = 0) then
    if (StSatz = 16) then Inc(BP16); endif;
    if (StSatz = 19) then Inc(BP19); endif;
	  if (StSatz =  5) then Inc(BP5);  endif;
    if (StSatz =  7) then Inc(BP7);  endif;
  endif;
  %TA_Pos.Next;
endwhile;

OK1 := 0;
OK2 := 0;
if BP16 > 0 then Inc(OK1); endif;
if BP19 > 0 then Inc(OK1); endif;
if BP5  > 0 then Inc(OK2); endif;
if BP7  > 0 then Inc(OK2); endif;

if ((OK1 > 1) or (OK2 > 1)) then 
   S  := 'Achtung.' + CHR(13,10) +
         'Die Belegpositionen sind hinsichtlich des Steuersatzes unstimmig.' + CHR(13,10) +
         'Bitte berprfen Sie den Beleg!';
   S1 := CHR(9) + 'Satz' + CHR(9) +  'Anzahl' + CHR(13,10);
   if(OK1 > 1)then
       S1 := S1 + CHR(9) + '16' + CHR(9) + BP16 + CHR(13,10)
       + CHR(9) + '19' + CHR(9) + BP19 + CHR(13,10);
   endif;
   if(OK2 > 1)then
       S1 := S1 + CHR(9) + '5' + CHR(9) + BP5 + CHR(13,10)
       + CHR(9) + '7' + CHR(9) + BP7 + CHR(13,10);
   endif;
   Show(S + CHR(13,10,13,10) + S1); 
else
   if Question('Der Beleg ist hinsichtlich des Steuersatzes in Ordnung.' + CHR(13,10) + 
               'Soll der Steuersatz dennoch neu gesetzt werden?','?','J_N') = false then
      exit;  
   endif;  
endif;
//**********************Steuersatz setzen*************
:SteuerSetzen  
Satz := SollSatz;
Satz2 := SollSatz2;

if (OK1 > 0) then
	if input(Satz,'Bitte Steuersatz in Prozent eingeben','16% oder 19%') = 0 then
	   GoTo Ende;
	endif;
	Satz := StrToInt(Satz);
	if (Satz <> 16) and (Satz <> 19) then
	   Question('Fehler bei Steuersatzangabe!','!','_O');
	   exit;
	endif; 
endif;


if (OK2 > 0) then
	if input(Satz2,'Bitte Steuersatz in Prozent eingeben','5% oder 7%') = 0 then
	   GoTo Ende;
	endif;
	Satz2 := StrToInt(Satz2);
	if (Satz2 <> 5) and (Satz2 <> 7) then
	   Question('Fehler bei Steuersatzangabe!','!','_O');
	   exit;
	endif; 
endif;


%TA_Pos.First;
while %TA_Pos.EOF = false do
   if (%TA_Pos.FieldByName('Artikelnr') <> '') and 
       ((%TA_Pos.FieldByName('Steuersatz') = 16.00) or (%TA_Pos.FieldByName('Steuersatz') = 19.00)) and
       (%TA_Pos.FieldByName('Steuersatz') <> Satz) and 
       (Pos(%TA_Pos.FieldByName('KzDruck'),'PESTt') = 0) then
      %TA_Pos.edit;
      %TA_Pos.TextByName('Steuersatz',Satz);
      %TA_Pos.Post;
   endif;
   if ((%TA_Pos.FieldByName('Artikelnr') <> '') and 
       ((%TA_Pos.FieldByName('Steuersatz') = 5.00) or (%TA_Pos.FieldByName('Steuersatz') = 7.00)) and
       (%TA_Pos.FieldByName('Steuersatz') <> Satz2) and 
       (Pos(%TA_Pos.FieldByName('KzDruck'),'PESTt') = 0)) then
      %TA_Pos.edit;
      %TA_Pos.TextByName('Steuersatz',Satz2);
      %TA_Pos.Post;
   endif;
   %TA_Pos.Next;
endwhile;

:Ende
Question('Prfung/Umsetzung beendet!','!','_O');
exit;
