//******************************************************************************
// GDImbH  19.06.2020 letzte nderung 20.06.2020
// Corona-Konjunkturpaket Mehrwertsteuerabsenkung 2020
//
// Programm "P2_Button_BelegMaske_Datum_Steuersatz.prg"
// Funktion: Prfen+Setzen des Steuersatzes in den Positionen eines Beleges
//           in Abhngigkeit des Leistungsdatums
// Einsetzbar in GDI Busness Line ab Version 3.6
// Einzubinden in einen TsButton in die Belegmaske aller Belegarten (EK und VK)
//******************************************************************************

ZeitraumVon := StrToDate('01.07.2020');
ZeitraumBis := StrToDate('31.12.2020');

//**********Steuersprfung***************************
:SteuerPruefen
  SteuerNeu16 := 0;
  SteuerNeu5  := 0;
  SteuerAlt19 := 0;
  SteuerAlt7  := 0;
  %TA_Pos.First;
  while %TA_Pos.EOF = false do
    StSatz := %TA_Pos.FieldByName('Steuersatz');
    if (%TA_Pos.FieldByName('Artikelnr') <> '') and
       ((StSatz = 16.00) or (StSatz = 19.00) or (StSatz = 5.00) or (StSatz = 7.00)) and
       (Pos(%TA_Pos.FieldByName('KzDruck'),'PESTt') = 0) then
      DatumMe := %TA_Pos.FieldByName('DatumMe');

      // Position im Zeitraum
      if (DatumMe >= ZeitraumVon) and (DatumMe < ZeitraumBis + 1) then
        if(StSatz = 19.00) then Inc(SteuerAlt19); endif;
        if(StSatz = 7.00)  then Inc(SteuerAlt7);  endif;
      else
        if(StSatz = 16.00) then Inc(SteuerNeu16); endif;
        if(StSatz = 5.00)  then Inc(SteuerNeu5);  endif;
      endif;
    endif;
    %TA_Pos.Next;
  endwhile;

  if (SteuerNeu16 > 0) or (SteuerNeu5 > 0) or (SteuerAlt19 > 0) or (SteuerAlt7 > 0) then
    S  := 'Achtung.' + CHR(13,10) +
          'Die Belegpositionen sind hinsichtlich Datum/Steuersatz unstimmig.' + CHR(13,10) +
          'Bitte berprfen Sie den Beleg!';
    S1 := '';
    if SteuerAlt19 > 0 then
      S1 := S1 + 'Alter Steuersatz 19% im Zeitraum von ' + DateToStr(ZeitraumVon) + 
                 ' bis ' + DateToStr(ZeitraumBis) + '.' + CHR(13,10);
    endif;
    if SteuerAlt7 > 0 then
      S1 := S1 + 'Alter Steuersatz 7% im Zeitraum von '  + DateToStr(ZeitraumVon) + 
                 ' bis ' + DateToStr(ZeitraumBis) + '.' + CHR(13,10);
    endif;
    if SteuerNeu16 > 0 then
      S1 := S1 + 'Neuer Steuersatz 16% auerhalb des Zeitraums von ' + DateToStr(ZeitraumVon) + 
                 ' bis ' + DateToStr(ZeitraumBis) + '.'+ CHR(13,10);
    endif;
    if SteuerNeu5 > 0 then
      S1 := S1 + 'Neuer Steuersatz 5% auerhalb des Zeitraums von ' + DateToStr(ZeitraumVon) + 
                 ' bis ' + DateToStr(ZeitraumBis) + '.'+ CHR(13,10);
    endif;
    if Question(S + CHR(13,10,13,10) + S1 + CHR(13,10) +
                'Sollen die Steuerstze korrigiert werden?','?','J_N') = false then
      exit;
    endif;
  else
    Show('Der Beleg ist hinsichtlich Datum/Steuersatz in Ordnung.');
    exit;
  endif;

//**********************Steuersatz setzen*************
  %TA_Pos.First;
  while %TA_Pos.EOF = false do
    StSatz := %TA_Pos.FieldByName('SteuerSatz');
    DatumMe := %TA_Pos.FieldByName('DatumMe');
    if (%TA_Pos.FieldByName('Artikelnr') <> '') and
       ((StSatz = 16.00) or (StSatz = 19.00) or (StSatz = 5.00) or (StSatz = 7.00)) and
       (Pos(%TA_Pos.FieldByName('KzDruck'),'PESTt') = 0) then
      if (DatumMe >= ZeitraumVon) and (DatumMe < ZeitraumBis + 1) then
        if StSatz = 19.00 then
          %TA_Pos.Edit;
          %TA_Pos.TextByName('Steuersatz',16.00);
          %TA_Pos.Post;
        endif;
        if StSatz = 7.00 then
          %TA_Pos.Edit;
          %TA_Pos.TextByName('Steuersatz',5.00);
          %TA_Pos.Post;
        endif;
      else
        if StSatz = 16.00 then
          %TA_Pos.Edit;
          %TA_Pos.TextByName('Steuersatz',19.00);
          %TA_Pos.Post;
        endif;
        if StSatz = 5.00 then
          %TA_Pos.Edit;
          %TA_Pos.TextByName('Steuersatz',7.00);
          %TA_Pos.Post;
        endif;
      endif;
    endif;
    %TA_Pos.Next;
  endwhile;
  GoTo SteuerPruefen;  

exit;

