//******************************************************************************
// GDImbH  19.06.2020 letzte nderung 20.06.2020
// Corona-Konjunkturpaket Mehrwertsteuerabsenkung 2020
//
// Programm "P3_Button_BelegUebMaske_Steuersatz.prg"
// Funktion: Prfen des Ziel- und der Quellebelege in der Belegbernahmemaske
// Einsetzbar in GDI Busness Line ab Version 3.6
// Einzubinden in einen TsButton in die Belegbernahmemaske 
// Wichtig: Button muss auf die zweite Karteiseite gelegt werden!
//****************************************************************************** 
CR  := Chr(13,10);
CR2 := Chr(13,10,13,10);
// Hauptbeleg: Prfen nur bei Option "Anhngen"  
if @CH_Append.Checked then
  Anz1 := 0;
  Anz2 := 0;
  Loop := 1;
  // Zweifache Prfung: 19/16 und 7/5
  while Loop <= 2 do
    if Loop = 1 then
      SollSatzAlt := 19.00;
      SollSatzNeu := 16.00;
    else  
      SollSatzAlt := 7.00;
      SollSatzNeu := 5.00;
    endif;  
  
    SQL := 'select distinct steuersatz ' +
           ' from belegpos ' +
           ' where steuersatz in (' + SollSatzAlt + ',' + SollSatzNeu + ') and ' +
           ' ((not kzdruck in (''P'',''E'',''S'',''T'',''t'')) or (KzDruck is null)) and ' +
           ' BelegNr = :BelegNr and BelegTyp = :BelegTyp and BelegArt = :BelegArt';
    %SQ.CreateSQuery(SQL);
    Satz := 0;
    StartBP16   := 0;
    StartBP19   := 0;
    StartBP07   := 0;
    StartBP05   := 0;
    StartBP16Nr := 0;
    StartBP19Nr := 0;
    StartBP07Nr := 0;
    StartBP05Nr := 0;
    Anz := 0;

    //Beleg, aus welchem die bernahme aufgerufen wurde
    StartBelegTyp := TA_Beleg2.BelegTyp;
    StartBelegArt := TA_Beleg2.BelegArt;
    StartBelegNr  := TA_Beleg2.BelegNr;
    %SQ.ParamByName('BelegNr',StartBelegNr);
    %SQ.ParamByName('BelegTyp',StartBelegTyp);
    %SQ.ParamByName('BelegArt',StartBelegArt);
    %SQ.ExecQuery;

    Satz := %SQ.FieldByName('Steuersatz');
    if Satz = 16.00 then 
      StartBP16   := 1; StartBP16NR := StartBelegNr; StartBPSatz := 16;    
    endif;
    if Satz = 19.00 then 
      StartBP19   := 1; StartBP19NR := StartBelegNr; StartBPSatz := 19;
    endif;
    if Satz = 5.00 then 
      StartBP05   := 1; StartBP05NR := StartBelegNr; StartBPSatz := 05;
    endif;
    if Satz = 7.00 then 
      StartBP07   := 1; StartBP07NR := StartBelegNr; StartBPSatz := 07;    
    endif;

    if Loop = 1 then
      Anz1 := %SQ.RecordCount;
    else  
      Anz2 := %SQ.RecordCount;
    endif;
    %SQ.FreeSQuery;  
    Inc(Loop);
  endwhile;  
  if (Anz1 > 1) or (Anz2 > 1) then
    Question('Achtung. ' + CR + 
             'Der in der Belegbearbeitung befindliche Beleg beinhaltet die beiden ' + CR + 
             'Steuerstze 16% und 19% bzw. 5% und 7%. Der Beleg ist somit in sich unstimmig!' + CR +
             '==> Beleg: ' + StartBelegTyp + StartBelegArt + ' ' + StartBelegNr + CR2 +
             'Bitte den Beleg vor der Belegbernahme korrigieren!','!','_O');
    exit;
  endif;
endif;  

// Prfung der zur bernahme selektierte Belege
Satz   := 0;
BP16   := 0;
BP19   := 0;
BP05   := 0;
BP07   := 0;
BP16Nr := 0;
BP19Nr := 0;
BP05Nr := 0;
BP07Nr := 0;
Anz    := 0;
ok     := 0;
%TA_Beleg.First;
while %TA_beleg.EOF = false do
  Anz1 := 0;
  Anz2 := 0;
  Loop := 1;
  // Zweifache Prfung: 19/16 und 7/5
  while Loop <= 2 do
    if Loop = 1 then
      SollSatzAlt := 19.00;
      SollSatzNeu := 16.00;
    else  
      SollSatzAlt := 7.00;
      SollSatzNeu := 5.00;
    endif;  

    SQL := 'select distinct steuersatz ' +
	         ' from belegpos ' +
	         ' where steuersatz in (' + SollSatzAlt + ',' + SollSatzNeu + ') ' +
	         ' and ((not kzdruck in (''P'',''E'',''S'',''T'',''t'')) or (kzdruck is null)) ' +
	         ' and Belegnr  = :Belegnr and BelegTyp = :BelegTyp and BelegArt = :BelegArt';
    %SQ.CreateSQuery(SQL);
    BelegNr  := %TA_Beleg.FieldByName('BelegNr');
    BelegTyp := %TA_Beleg.FieldByName('BelegTyp');
    BelegArt := %TA_Beleg.FieldByName('BelegArt');
    %SQ.ParamByName('BelegNr',  BelegNr);
    %SQ.ParamByName('BelegTyp', BelegTyp);
    %SQ.ParamByName('BelegArt', BelegArt);
    %SQ.ExecQuery;
    Satz := %SQ.FieldByName('Steuersatz');
    if Satz = 16.00 then 
      BP16   := 1; BP16NR := BelegNr;    
    endif;
    if Satz = 19.00 then 
      BP19   := 1; BP19NR := BelegNr;
    endif;
    if Satz = 5.00 then 
      BP05   := 1; BP05NR := BelegNr;    
    endif;
    if Satz = 7.00 then 
      BP07   := 1; BP07NR := BelegNr;
    endif;

    if Loop = 1 then
      Anz1 := %SQ.RecordCount;
    else  
      Anz2 := %SQ.RecordCount;
    endif;
    %SQ.FreeSQuery;  
    Inc(Loop);
  endwhile;  

  if (Anz1 > 1) or (Anz2 > 1) then
    Question('Achtung. ' + CR + 
             'Es wurde mindestens ein Beleg selektiert, welcher die beiden ' + CR + 
             'Steuerstze 16% und 19% oder 5% und 7% gleichzeitig beinhaltet.' + CR +
             '==> Belegnr: ' + BelegNr + CR2 +
             'Bitte den Beleg vor der Belegbernahme korrigieren!','!','_O');
    %TA_Beleg.First;
    exit;
  endif;
  %TA_Beleg.Next;
endwhile;

if (BP16 = 1) and (BP19 = 1) then
  Question('Achtung. ' + CR + 
           'Es sind Belege mit Steuersatz 16 und Belege mit Steuersatz 19 Prozent selektiert.' + CR + 
           '==> Belegnr mit 16%%: ' + BP16Nr + CR +
           '==> Belegnr mit 19%%: ' + BP19Nr + CR +
           'Der in der Belegbearbeitung befindliche Beleg beinhaltet den Steuersatz ' + StartBPSatz + ' Prozent.' + CR2 + 
           'Eine korrekte bernahme ist nur bei Einzelbernahme mglich!' + CR +
           'Die Optionen Anhngen und Zusammmenfassen fhren zu Fehlern!','!','_O');
  %TA_Beleg.First;
  exit;
endif; 

if (BP07 = 1) and (BP05 = 1) then
  Question('Achtung. ' + CR +
           'Es sind Belege mit Steuersatz 7 und Belege mit Steuersatz 5 Prozent selektiert.' + CR + 
           '==> Belegnr mit 7%: ' + BP07Nr + CR +
           '==> Belegnr mit 5%: ' + BP05Nr + CR + 
           'Der in der Belegbearbeitung befindliche Beleg beinhaltet den Steuersatz ' + StartBPSatz + ' Prozent.' + CR2 + 
           'Eine korrekte bernahme ist nur bei Einzelbernahme mglich!' + CR + 
           'Die Optionen Anhngen und Zusammmenfassen fhren zu Fehlern!','!','_O');
  %TA_Beleg.First;
  exit;
endif; 

if (BP16 = 1) and (StartBP19 = 1) then
  Question('Achtung. ' + CR + 
           'Der in der Belegbearbeitung befindliche Beleg beinhaltet den Steuersatz 19 Prozent.' + CR + 
           'Die zur bernahme selektierten Belege enthalten den Steuersatz 16 Prozent.' + CR2 +
           'Die Optionen Anhngen und Zusammmenfassen fhren zu Fehlern!','!','_O');
  Inc(ok);
endif; 

if (BP07 = 1) and (StartBP05 = 1) then
  Question('Achtung. ' + CR +
           'Der in der Belegbearbeitung befindliche Beleg beinhaltet den Steuersatz 5 Prozent.' + CR + 
           'Die zur bernahme selektierten Belege enthalten den Steuersatz 7 Prozent.' + CR2 + 
           'Die Optionen Anhngen und Zusammmenfassen fhren zu Fehlern!','!','_O');
  Inc(ok);
endif; 

if (BP19 = 1) and (StartBP16 = 1) then
  Question('Achtung. ' + CR + 
           'Der in der Belegbearbeitung befindliche Beleg beinhaltet den Steuersatz 16 Prozent.' + CR + 
           'Die zur bernahme selektierten Belege enthalten den Steuersatz 19 Prozent.' + CR2 + 
           'Die Optionen Anhngen und Zusammmenfassen fhren zu Fehlern!','!','_O');
  Inc(ok);
endif; 

if (BP05 = 1) and (StartBP07 = 1) then
  Question('Achtung. ' + CR + 
           'Der in der Belegbearbeitung befindliche Beleg beinhaltet den Steuersatz 7 Prozent.' + CR + 
           'Die zur bernahme selektierten Belege enthalten den Steuersatz 5 Prozent.' + CR2 +
           'Die Optionen Anhngen und Zusammmenfassen fhren zu Fehlern!','!','_O');
  Inc(ok);
endif; 

%TA_Beleg.First;
if ok = 0 then
  Question('Steuersatz-Prfung 16/19/5/7.' + CR2 + 
           'Es wurden keine Unstimmigkeiten gefunden.' + CR2 +
           'Die Belegbernahme kann durchgefhrt werden!','*','_O');
endif; 
exit;
